#define _GNU_SOURCE

#include <stdio.h>
#include <dlfcn.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>

static int (*libc_open)(const char *pathname, int flags, ...) = NULL;

int open(const char *pathname, int flags, ...)
{
	if(flags & O_CREAT){
		errno = EACCES;
		return -1;
	}

	if(!libc_open){
		libc_open = dlsym(RTLD_NEXT, "open");

		if(!libc_open) exit(1);
	}
	
	flags = flags & ~(O_WRONLY | O_RDWR);
	flags = flags | O_RDONLY;

	return libc_open(pathname, flags);
}

int creat(const char *pathname, mode_t mode)
{
	errno = EACCES;

	return -1;
}
